#pragma once

#include "DropConfig.h"

class DefaultBlockItemDrop : public DropConfig
{
public:
    DefaultBlockItemDrop();
    void doDrop(Entity* zActor,
        Item* zItem,
        ItemSkill* zUsedSkill,
        Framework::Either<Block*, Entity*> zDestroyedObject) const override;
};

class DefaultBlockItemDropFactory
    : public DropConfigFactory<DefaultBlockItemDrop>
{
public:
    DefaultBlockItemDropFactory();
    JSONObjectValidationBuilder* addToValidator(
        JSONObjectValidationBuilder* builder) const override;
    const char* getTypeToken() const override;
    DefaultBlockItemDrop* createInstance(
        Framework::JSON::JSONObject* zJson) const override;
    void addToJson(Framework::JSON::JSONObject* zJson,
        DefaultBlockItemDrop* zObject) const override;
};