#pragma once

#include "DropConfig.h"

class DefaultInventoryItemDrop : public DropConfig
{
public:
    DefaultInventoryItemDrop();
    void doDrop(Entity* zActor,
        Item* zItem,
        ItemSkill* zUsedSkill,
        Framework::Either<Block*, Entity*> zDestroyedObject) const override;
};

class DefaultInventoryItemDropFactory
    : public DropConfigFactory<DefaultInventoryItemDrop>
{
public:
    DefaultInventoryItemDropFactory();
    JSONObjectValidationBuilder* addToValidator(
        JSONObjectValidationBuilder* builder) const override;
    const char* getTypeToken() const override;
    DefaultInventoryItemDrop* createInstance(
        Framework::JSON::JSONObject* zJson) const override;
    void addToJson(Framework::JSON::JSONObject* zJson,
        DefaultInventoryItemDrop* zObject) const override;
};